@echo off
title AsmBuild
%~d1
chdir %~dp1
set oBody=%~n1
echo.
echo *** Assemble, link and run %oBody% ***
echo.
if exist "%oBody%.obj" del "%oBody%.obj"
if exist "%oBody%.exe" del "%oBody%.exe"

if exist "%oBody%.rc" (
\masm32\bin\rc /fo rsrc.res "%oBody%.rc"
goto AssRun
)

if exist rsrc.rc \masm32\bin\rc rsrc.rc

:AssRun
if exist rsrc.res (\masm32\bin\cvtres /machine:ix86 rsrc.res)
\masm32\bin\ml /nologo /Fl /Sn /c /coff /Fo "%oBody%" tmp_file.asm

if errorlevel 1 goto errasm

if not exist rsrc.obj goto nores

\masm32\bin\link /SUBSYSTEM:WINDOWS "%oBody%.obj" rsrc.obj

if errorlevel 1 goto errlink
goto LinkOk

:nores
\masm32\bin\link /SUBSYSTEM:WINDOWS "%oBody%.obj"
if errorlevel 1 goto errlink

:LinkOk
dir "%oBody%.*"

"%oBody%.exe"
goto TheEnd

:errlink
echo.
echo *** Link error ***
goto errtitle

:errasm
echo.
echo *** Assembly Error ***

:errtitle
title AB error
pause
goto TheEnd

:TheEnd
del tmp_file.lst
del tmp_file.asm
